Package com.io7m.coffeepick.runtime

# Interface RuntimeDescriptionType

All Known Implementing Classes:
  `RuntimeDescription`

    @Immutable
    public interface RuntimeDescriptionType

A runtimes of a runtime.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.lang.String` | `architecture()` |
  `RuntimeHash` | `archiveHash()` |
  `long` | `archiveSize()` |
  `java.net.URI` | `archiveURI()` |
  `java.util.Optional<RuntimeBuild>` | `build()` |
  `RuntimeConfiguration` | `configuration()` |
  `default java.lang.String` | `id()` |
  `java.lang.String` | `platform()` |
  `java.net.URI` | `repository()` |
  `default java.util.Set<java.lang.String>` | `tags()` |
  `RuntimeVersion` | `version()` |
  `java.lang.String` | `vm()` |

- ## Method Details

  - ### repository

    java.net.URI repository()
    Returns:
      The repository to which this runtime belongs

  - ### version

    RuntimeVersion version()
    Returns:
      The runtime version

  - ### configuration

    RuntimeConfiguration configuration()
    Returns:
      The JVM configuration

  - ### platform

    java.lang.String platform()
    Returns:
      The name of the platform upon which this runtime will run
    See Also:
      `RuntimePlatforms`

  - ### architecture

    java.lang.String architecture()
    Returns:
      The name of the architecture upon which this runtime will run
    See Also:
      `RuntimeArchitectures`

  - ### archiveURI

    java.net.URI archiveURI()
    Returns:
      A URI that can be used to fetch an archive of the runtime

  - ### archiveSize

    long archiveSize()
    Returns:
      The size in octets of the archive

  - ### archiveHash

    RuntimeHash archiveHash()
    Returns:
      The hash of the runtime

  - ### vm

    java.lang.String vm()
    Returns:
      The name of the VM used in the runtime
    See Also:
      `RuntimeVMs`

  - ### build

    java.util.Optional<RuntimeBuild> build()
    Returns:
      The build information

  - ### tags

    @Default default java.util.Set<java.lang.String> tags()
    Returns:
      A set of arbitrary tags added to the runtime

  - ### id

    default java.lang.String id()
    Returns:
      A unique identifier for this runtime